platform.apilevel = "2.0"

play = 2
gridsize = 2
sel = 1
erg1 = 0
erg2 = 0
input = ""

rs = 1
rr = 1

w = platform.window:width()
h = platform.window:height()


function on.paint(gc)
    gc:setColorRGB(0,0,0)
    ------------------------------------
    if play == 0 then
        grid()
        
        tt = true
        while tt == true do
            for c1 = 1,gridsize,1 do
                for c2 = 1,gridsize,1 do
                    gr[c1][c2] = math.random(1,9)
                end
            end
            for c1 = 1,gridsize-1,1 do
                for c2 = 1,gridsize-1,1 do
                    if gr[c1][c2] == gr[c1][c2+1] or gr[c1][c2] == gr[c1+1][c2] then
                    
                        tt = true
                    else
                        tt = false
                    end    
                end
            end
            if tt1 == false then
                tt = true
            end
        end
        
        play = 1
        platform.window:invalidate()
    end
    if play == 1 then
        
        
        gc:setColorRGB(200,0,0)
        gc:fillRect(w/2 - (sz)/2 + 0*sz - (sz*((gridsize)/2)),h/2 - (sz)/2 + 0*sz - (sz*((gridsize)/2)),sz,sz)
        gc:setColorRGB(0,0,0)
        
        for i1 = 0,gridsize,1 do
            for i2 = 0,gridsize,1 do
                gc:drawRect(w/2 - (sz)/2 + i1*sz - (sz*((gridsize)/2)),h/2 - (sz)/2 + i2*sz - (sz*((gridsize)/2)),sz,sz)
            end
        end
        gc:setFont("sansserif","r",20)
        for b1 = 1,gridsize,1 do
            for b2 = 1,gridsize,1 do
                gc:drawString(grl[b1][b2],w/2 - ((gridsize/2 -1)*sz) - (gc:getStringWidth(grl[b1][b2])/2) + ((b2 - 1)*sz) + 2,h/2 - ((gridsize/2-1.5)*sz) - hc + ((b1 - 1)*sz))
                erg1 = erg1 + gr[b1][b2]
                erg2 = erg2 + gr[b2][b1]
            end
            if erg2 <= 9 then
                erg2 = "0"..tostring(erg2)
            end
            if erg1 <= 9 then
                erg1 = "0"..tostring(erg1)
            end
            gc:drawString(erg1,w/2 - ((gridsize/2 -1)*sz) - gc:getStringWidth(erg1) + ((0 - 1)*sz) + 19,h/2 - ((gridsize/2-1.5)*sz) - hc + ((b1-1)*sz))
            gc:drawString(erg2,w/2 - ((gridsize/2-1)*sz) - gc:getStringWidth(erg2) + ((b1-1)*sz) + 19,h/2 - ((gridsize/2-0.5)*sz) - hc)
            --if erg1 == erg2 then
                --play = 0
            --end
            erg1 = 0
            erg2 = 0
        end
            
            gc:setColorRGB(0,200,50)
            gc:drawRect(w/2 - (sz)/2 + (rs * sz) - (sz*((gridsize)/2)),h/2 - (sz/2) + (rr*sz) - (sz*((gridsize)/2)),sz,sz)
            gc:drawRect(w/2 - (sz)/2 + (rs * sz) - (sz*((gridsize)/2))+2,h/2 - (sz/2) + (rr*sz) - (sz*((gridsize)/2))+2,sz-4,sz-4)
            
            gc:setColorRGB(0,0,200)
            gc:drawString(input,30,105)
            gc:setColorRGB(0,0,0)
              
            platform.window:invalidate()
        
    elseif play == 2 then
        gc:setFont("sansserif","r",20)
        if sel == 1 then
            gc:drawString("< START >",w/2-gc:getStringWidth("< START >")/2,50)
        else
            gc:drawString(" START ",w/2-gc:getStringWidth(" START ")/2,50)
        end
        if sel == 2 then
            gc:drawString("< GRIDSIZE: "..gridsize.." >",w/2-gc:getStringWidth("< GRIDSIZE: "..gridsize.." >")/2,100)
        else
            gc:drawString(" GRIDSIZE: "..gridsize,w/2-gc:getStringWidth(" GRIDSIZE: "..gridsize)/2,100)
        end
        gc:setFont("sansserif","r",10)
        gc:drawString(" Check if everything is right by pressing C. ",w/2-gc:getStringWidth(" Check if everything is right by pressing C. ")/2,120)
        gc:drawString(" Navigate with the arrow keys. ",w/2-gc:getStringWidth(" Navigate with the arrow keys. ")/2,135)
        gc:drawString(" Enter the numbers in such a way that the result of the ",w/2-gc:getStringWidth(" Enter the numbers in such a way that the result of the ")/2,150)
        gc:drawString(" addition gives the numbers at the edges. ",w/2-gc:getStringWidth(" addition gives the numbers at the edges. ")/2,165)
        gc:drawString(" No number may be duplicated in a column or row. ",w/2-gc:getStringWidth(" No number may be duplicated in a column or row. ")/2,180)
        gc:drawString(" Use the arrow keys to select the gridsize. ",w/2-gc:getStringWidth(" Use the arrow keys to select the gridsize. ")/2,195)
        gc:drawString(" Start by ENTERing Start. ",w/2-gc:getStringWidth(" Start by ENTERing Start. ")/2,210)
    end
    timer.start(0.1)
    platform.window:invalidate()
end

platform.window:invalidate()

function grid()
    if gridsize == 2 then
        gr = {{0,0},{0,0}}
        grl = {{0,0},{0,0}}
        sz = 65
        hc = 10
    elseif gridsize == 3 then
        gr = {{0,0,0},{0,0,0},{0,0,0}}
        grl = {{0,0,0},{0,0,0},{0,0,0}}
        sz = 50
        hc = 5
    elseif gridsize == 4 then
        gr = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}
        grl = {{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}}
        sz = 40
        hc = 0
    end
end

function on.arrowUp()
	if play == 1 then
        if rr ~= 1 then
            rr = rr - 1
        end
    elseif play == 2 then
        if sel == 2 then
            sel = 1
        end
	end
	platform.window:invalidate()
end

function on.arrowDown()
	if play == 1 then
         if rr ~= gridsize then
            rr = rr + 1
        end
    elseif play == 2 then
            if sel == 1 then
                sel = 2
            end
    end
	platform.window:invalidate()
end

function on.arrowLeft()
	if play == 1 then
        if rs ~= 1 then
            rs = rs - 1
        end
    elseif play == 2 then
            if sel == 2 then
                if gridsize >= 3 then
                    gridsize = gridsize - 1
                else
                    gridsize = 4
                end
            end
    end
	platform.window:invalidate()
end

function on.arrowRight()
	if play == 1 then
        if rs ~= gridsize then
            rs = rs + 1
        end
    elseif play == 2 then
        if sel == 2 then
            if gridsize <= 3 then
                gridsize = gridsize + 1
            else
                gridsize = 2
            end
        end
    end
	platform.window:invalidate()
end

 function on.charIn(char)
    if play == 1 then
        if char == "c" then
            check()
        else
            grl[rr][rs] = char
        end
    end
    platform.window:invalidate()   -- refreshing the screen
end

function check()
    t1 = false
    t2 = false
    erg4 = 0
    erg5 = 0
    erg6 = 0
    erg7 = 0
    for c1 = 1,gridsize,1 do
        for c2 = 1,gridsize,1 do
            erg4 = erg4 + grl[c1][c2]
            erg5 = erg5 + gr[c1][c2]
        end
    end
    for c1 = 1,gridsize,1 do
        for c2 = 1,gridsize,1 do
            erg6 = erg6 + grl[c2][c1]
            erg7 = erg7 + gr[c2][c1]
        end
    end
   for c1 = 1,gridsize,1 do
        for c2 = 1,gridsize-1,1 do
            if grl[c1][c2] == grl[c1][c2+1] then
                erg4 = 0
            end
        end
    end
    if erg4 == erg5 then
        t1 = true
    end
    if erg6 == erg7 then
        t2 = true
    end
    if t1 == true and t2 == true then
        input = "!!!CORRECT!!!"
    else
        input = ""
    end
    platform.window:invalidate()
end

function on.timer()
  timer.stop()
  platform.window:invalidate()
end

function on.enterKey()
    if play == 1 then
        if input == "!!!CORRECT!!!" then
            play = 0
        end
    elseif play == 2 then
        if sel == 1 then
            play = 0
        end
    end
    platform.window:invalidate()
end

function on.escapeKey()
    if play == 1 then
        play = 2
    end
    platform.window:invalidate()
end